extern uint32_t *__stack_chk_guard;

bool check_stack_bug(uint32_t const *data, int dump_len)
{
    for (int i = 0; i < dump_len; i++)
    {
        console_printf("%p : %p\n", &data[i], data[i]);
        if (data[i] == (const uint32_t)&__stack_chk_guard)
        {
            console_printf(
                "canary is at offset %d from dummy and equals to the address of __stack_chk_guard\n",
                i);
            return true;
        }
    }
    return false;
}

static int app_stack_guard_cmd_handler()
{

    // A dummy var to get the stack frame address
    uint32_t dummy = 0x57AC57AC;

    bool is_buggy = check_stack_bug((uint32_t const *)&dummy, 5);
    if (is_buggy)
        _console_printf("stack protection bug detected\n");
}
